# Time window

A decision block that checks, or awaits a specific or recurring window of time.

If the proceed option is set to Immediately, then instantly check if the current time, or the supplied timestamp, is within the window of time without pausing the fiber. If is set to Inexact or Exact, then the fiber will pause until the time of day and proceed through the YES path (every odd visit), or until the end of the duration and proceed through the NO path (every even visit).

Additionally, if Inexact the fiber may proceed at a later time to “batch” alarms together across the system, minimizing battery use, if Exact the fiber will proceed as timely as possible.

Note! Accurate timing is impossible on Android 6 though 11, expect up to 15 minutes inaccuracy. Accuracy may be improved by using a Timing accuracy workaround in settings, shouldn’t be necessary on Android 12+.

### Usage examples

- Check if the current time, or any other timestamp, is within a window of time.
- Switch something on and off during some fixed or recurring times.

## Options

- Proceed — accuracy and mode of operation.

## Input arguments

- Timestamp — unix timestamp to check, default is current time, only used with Immediately.
- Duration — duration of the time window in seconds, starting at time of day, default is the duration until midnight.
- Time of day — time of day, seconds past midnight, default is midnight.
- Weekdays — limit to weekdays, default is every weekday.
- Day of month — limit to day of month, default is every day of the month.
- Month — limit to month, default is every month.
- Year — limit to year, default is every year.
- Time zone — time zone for window of time and timestamp, default is the current time zone.
- Wake up — whether the device should awake from sleep, only used with proceed Inexact and Exact.